'use strict';

exports.__esModule = true;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = function (obj, opts) {
  var root = _postcss2.default.root(opts);
  parse(obj, root);
  return root;
};

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _CSSProperty = require('./glamor/CSSPropertyOperations/CSSProperty');

var _CSSProperty2 = _interopRequireDefault(_CSSProperty);

var _CSSPropertyOperations = require('./glamor/CSSPropertyOperations');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function decl(parent, name, value) {
  if (value === false || value === null) return;

  name = (0, _CSSPropertyOperations.processStyleName)(name);
  if (typeof value === 'number') {
    if (value === 0 || _CSSProperty2.default[name] === 1) {
      value = value.toString();
    } else {
      value += 'px';
    }
  }

  if (name === 'css-float') name = 'float';

  parent.push(_postcss2.default.decl({ prop: name, value: value }));
}

function atRule(parent, parts, value) {
  var node = _postcss2.default.atRule({ name: parts[1], params: parts[3] || '' });
  if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') {
    node.nodes = [];
    parse(value, node);
  }
  parent.push(node);
}

function parse(obj, parent) {
  var name, value, node, i;
  for (name in obj) {
    if (obj.hasOwnProperty(name)) {
      value = obj[name];
      if (name[0] === '@') {
        var parts = name.match(/@([^\s]+)(\s+([\w\W]*)\s*)?/);
        if (Array.isArray(value)) {
          for (i = 0; i < value.length; i++) {
            atRule(parent, parts, value[i]);
          }
        } else {
          atRule(parent, parts, value);
        }
      } else if (Array.isArray(value)) {
        for (i = 0; i < value.length; i++) {
          decl(parent, name, value[i]);
        }
      } else if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' && value !== null) {
        node = _postcss2.default.rule({ selector: name });
        parse(value, node);
        parent.push(node);
      } else {
        decl(parent, name, value);
      }
    }
  }
}